//+------------------------------------------------------------------+
//|                                                     Fractals.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_width1 1
#property indicator_width2 1
//---- input parameters
extern int strength = 5;
//---- buffers
double ExtUpFractalsBuffer[];
double ExtDownFractalsBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping  
    SetIndexBuffer(0,ExtUpFractalsBuffer);
    SetIndexBuffer(1,ExtDownFractalsBuffer);   
//---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,116);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,116);
//----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
//---- name for DataWindow
    SetIndexLabel(0,"Fractal Up");
    SetIndexLabel(1,"Fractal Down");
//---- initialization done   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,nCountedBars;
   bool   bFound;
   double dCurrent;
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted    
   if(nCountedBars<=2)
      i=Bars-nCountedBars-5;
   if(nCountedBars>2)
     {
      nCountedBars--;
      i=Bars-nCountedBars-1;
     }
//----Up and Down Fractals
   while(i>=2)
     {
      //----Fractals up
      bFound=false;
      dCurrent=High[i];
      
      if(dCurrent>High[i+1] && dCurrent>High[i+2] && dCurrent>High[i+3] && dCurrent>High[i+4] && dCurrent>High[i+5] && dCurrent>=High[i-1] && dCurrent>=High[i-2] && dCurrent>=High[i-3] && dCurrent>=High[i-4] && dCurrent>=High[i-5])
        {
         bFound=true;
         ExtUpFractalsBuffer[i]=dCurrent;
        }                                
      //----Fractals down
      bFound=false;
      dCurrent=Low[i];
      if(dCurrent<Low[i+1] && dCurrent<Low[i+2] && dCurrent<Low[i+3] && dCurrent<Low[i+4] && dCurrent<Low[i+5] && dCurrent<=Low[i-1] && dCurrent<=Low[i-2] && dCurrent<=Low[i-3] && dCurrent<=Low[i-4] && dCurrent<=Low[i-5])
        {
         bFound=true;
         ExtDownFractalsBuffer[i]=dCurrent;
        }
      
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+